package com.example.bigsql.job;

import com.example.bigsql.service.CreateDatabasesByV3File;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

/**
 * 从sql文件恢复数据库定时任务
 * <p>
 * &#064;Auther:  whc
 * &#064;Date:  2024/3/08
 */

@Slf4j
@Service
@EnableScheduling
public class SqlRestorationJob {
    @Autowired
    private CreateDatabasesByV3File createDatabasesByV3File;

    //每半小时执行一次
    @Scheduled(fixedDelay = 300000)
    public void execute() throws Exception {
        log.info("开始执行读取sql文件定时任务");
        createDatabasesByV3File.redSqlZip();
        log.info("结束执行读取sql文件定时任务");
    }
}
