package com.example.bigsql.service;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class SQLtoCSVConverter {

    public static void main(String[] args) {

        String inputFilePath = "E:\\迅雷下载\\ipfcst-vv3.sql";
        String outputFilePath = ".csv";

        try {

            BufferedReader reader = new BufferedReader(new FileReader(inputFilePath));
            Map<String, FileWriter> fileWriterMap = new HashMap<>();
            String line;
            while ((line = reader.readLine()) != null) {
                if (line.trim().startsWith("INSERT")) {
                    String tableName = line.substring(13, line.indexOf("` VALUES"));
                    if (null == fileWriterMap.get(tableName)) {
                        fileWriterMap.put(tableName, new FileWriter("E:\\迅雷下载\\csvdir\\" + tableName + outputFilePath));
                    }
                    // 解析SQL语句，提取数据
                    String[] data = parseSQLLine(line);
                    String[] data1 = data;
                    for (int i = 0; i < data.length; i++) {
                        if (data[i].equals("null")) {
                            data1[i] = null;
                        } else {
                            data1[i] = data[i];
                        }
                    }
                    if (data != null) {
                        // 将数据以CSV格式写入文件
                        fileWriterMap.get(tableName).write(String.join(",", data1));
                        fileWriterMap.get(tableName).write("\n");
                    }
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    // 解析SQL语句中的数据
    private static String[] parseSQLLine(String line) {
        if (line.trim().startsWith("INSERT")) {
            //解析INSERT语句中的数据
            int startIndex = line.indexOf("(");
            int endIndex = line.indexOf(")");
            if (startIndex == -1 || endIndex == -1) {
                return null;
            }
            String data = line.substring(startIndex + 1, endIndex).replaceAll("'", "");

            return data.replace(", ", ",").replace("\\", "").split(",");
        }
        return null;

    }
}
