package com.example.datadump.service;

import cn.hutool.core.io.FileUtil;
import com.example.datadump.util.FileUtils;
import org.springframework.stereotype.Service;

import java.io.File;
import java.sql.*;

@Service
public class DumpMysql {
    /**
     * 备份mysql数据库
     *
     * @param userName 用户名
     * @param passWord 密码
     * @param ip       IP地址
     * @param port     端口
     * @param db       数据库
     * @param table    表
     * @param outPath  输出路径
     */
    public void dbBackUpMysql(String userName, String passWord, String ip, String port, String db, String table, String outPath) throws Exception {
        Connection conn = null;
        PreparedStatement ps = null;
        ResultSet rs = null;
        String SQL = null;
        String url = "jdbc:mysql://" + ip + ":" + port + "/" + db + "?useUnicode=true&characterEncoding=utf8&zeroDateTimeBehavior=convertToNull&useSSL=true&serverTimezone=GMT%2B8&autoReconnect=true&rewriteBatchedStatements=true";
        //加载数据库驱动
        Class.forName("com.mysql.cj.jdbc.Driver");
        //创建连接
        conn = DriverManager.getConnection(url, userName, passWord);
        String regex = ",|，";
        String[] tables = table.split(regex);
        for (String table1 : tables) {
            String filePath = outPath + File.separator;
            if (!new File(filePath).exists()) {
                FileUtil.mkdir(filePath);
            }
            File[] files = FileUtils.searchFile(new File(filePath), table1);
            for (File file : files) {
                file.delete();
            }
            String fileName = table1 + ".csv";
            //执行语句
            SQL = "SELECT \r\n" +
                    "   *\r\n" +
                    "FROM \r\n" +
                    "   " + table1 + "\r\n" +
                    "into outfile '" + filePath + fileName + "'" +
                    "fields terminated by ',' " +
                    "lines terminated by '\\r\\n'";
            ps = conn.prepareStatement(SQL);
            rs = ps.executeQuery();
        }
        //关闭连接
        try {
            if (rs != null)
                rs.close();
            if (ps != null)
                ps.close();
            if (conn != null)
                conn.close();
        } catch (SQLException se) {
            se.printStackTrace();
        }
    }
}
